from machine import Pin,SPI,PWM
import framebuf
import time

#color is BGR
RED = 0x00F8
GREEN = 0xE007
BLUE = 0x1F00
WHITE = 0xFFFF
BLACK = 0x0000

class lcd_0inch96(framebuf.FrameBuffer):
    def __init__(self):
    
        self.width = 128
        self.height = 128
        
        self.cs = Pin(9,Pin.OUT)
        self.rst = Pin(12,Pin.OUT)
        self.bl = Pin(13,Pin.OUT)
        self.cs(1)
        # pwm = PWM(Pin(13))#BL
        # pwm.freq(1000)        
        self.spi = SPI(1)
        self.spi = SPI(1,1000_000)
        self.spi = SPI(1,10000_000,polarity=0, phase=0,sck=Pin(10),mosi=Pin(11),miso=None)
        self.dc = Pin(8,Pin.OUT)
        self.dc(1)
        self.buffer = bytearray(self.height * self.width * 2)
        super().__init__(self.buffer, self.width, self.height, framebuf.RGB565)
        self.Init()
        self.SetWindows(0, 0, self.width-1, self.height-1)
        
    def reset(self):
        self.rst(1)
        time.sleep(0.2) 
        self.rst(0)
        time.sleep(0.2)         
        self.rst(1)
        time.sleep(0.2) 
        
    def write_cmd(self, cmd):
        self.dc(0)
        self.cs(0)
        self.spi.write(bytearray([cmd]))

    def write_data(self, buf):
        self.dc(1)
        self.cs(0)
        self.spi.write(bytearray([buf]))
        self.cs(1)

    def backlight(self,value):#value:  min:0  max:1000
        pwm = PWM(Pin(13))#BL
        pwm.freq(1000)
        if value>=1000:
            value=1000
        data=int (value*65536/1000)       
        pwm.duty_u16(data)  
        
    def Init(self):
        self.reset() 
        self.backlight(10000)
        
        self.write_cmd(0x36) 
        self.write_data(0xC8) 
        
        self.write_cmd(0xB0);
        self.write_data(0xC0); 
        self.write_cmd(0xB2);
        self.write_data(0x2F); 
        self.write_cmd(0xB3);
        self.write_data(0x03);
        self.write_cmd(0xB6);
        self.write_data(0x19); 
        self.write_cmd(0xB7);
        self.write_data(0x01);  
        
        self.write_cmd(0xAC);
        self.write_data(0xCB);
        self.write_cmd(0xAB); 
        self.write_data(0x0e);
            
        self.write_cmd(0xB4);
        self.write_data(0x04);
        
        self.write_cmd(0xA8);
        self.write_data(0x19);

        self.write_cmd(0x3A);
        self.write_data(0x05); 

        self.write_cmd(0xb8);
        self.write_data(0x08);
     
        self.write_cmd(0xE8);
        self.write_data(0x24);

        self.write_cmd(0xE9);
        self.write_data(0x48);

        self.write_cmd(0xea);
        self.write_data(0x22);

                
        self.write_cmd(0xC6);
        self.write_data(0x30);
        self.write_cmd(0xC7);
        self.write_data(0x18);

        self.write_cmd(0xF0);
        self.write_data(0x1F);
        self.write_data(0x28);
        self.write_data(0x04);
        self.write_data(0x3E);
        self.write_data(0x2A);
        self.write_data(0x2E);
        self.write_data(0x20);
        self.write_data(0x00);
        self.write_data(0x0C);
        self.write_data(0x06);
        self.write_data(0x00);
        self.write_data(0x1C);
        self.write_data(0x1F);
        self.write_data(0x0f);

        self.write_cmd(0xF1); 
        self.write_data(0X00);
        self.write_data(0X2D);
        self.write_data(0X2F);
        self.write_data(0X3C);
        self.write_data(0X6F);
        self.write_data(0X1C);
        self.write_data(0X0B);
        self.write_data(0X00);
        self.write_data(0X00);
        self.write_data(0X00);
        self.write_data(0X07);
        self.write_data(0X0D);
        self.write_data(0X11);
        self.write_data(0X0f);
        

        self.write_cmd(0x21)  

        self.write_cmd(0x11) 
        
        self.write_cmd(0x29) 
         
         
        
    def SetWindows(self, Xstart, Ystart, Xend, Yend):#example max:0,0,159,79
        Xstart=Xstart+2
        Xend=Xend+2
        Ystart=Ystart+1
        Yend=Yend+1
        self.write_cmd(0x2A);
        self.write_data((Xstart >> 8) & 0xFF);
        self.write_data(Xstart & 0xFF);
        self.write_data(((Xend  ) >> 8) & 0xFF);
        self.write_data((Xend  ) & 0xFF);

        self.write_cmd(0x2B);
        self.write_data((Ystart >> 8) & 0xFF);
        self.write_data(Ystart & 0xFF);
        self.write_data(((Yend  ) >> 8) & 0xFF);
        self.write_data((Yend  ) & 0xFF);

        self.write_cmd(0x2C) 
        
    def display(self):
    
        self.SetWindows(0,0,self.width-1,self.height-1)       
        self.dc(1)
        self.cs(0)
        self.spi.write(self.buffer)
        self.cs(1)        
     
    def write_text(self,text,x,y,size,color):
        background = self.pixel(x,y)
        info = []
        # Creating reference charaters to read their values
        self.text(text,x,y,color)
        for i in range(x,x+(8*len(text))):
            for j in range(y,y+8):
                # Fetching amd saving details of pixels, such as
                # x co-ordinate, y co-ordinate, and color of the pixel
                px_color = self.pixel(i,j)
                info.append((i,j,px_color)) if px_color == color else None
        # Clearing the reference characters from the screen
        self.text(text,x,y,background)
        # Writing the custom-sized font characters on screen
        for px_info in info:
            self.fill_rect(size*px_info[0] - (size-1)*x , size*px_info[1] - (size-1)*y, size, size, px_info[2]) 
    
if __name__=='__main__':

    lcd = lcd_0inch96()   
    lcd.fill(BLACK)
    lcd.SetWindows(0,0,127,127)
    lcd.write_text("Hello",25,25,2,GREEN)
    lcd.write_text("pico!",25,45,2,GREEN)   
    lcd.write_text("This is",8,65,2,GREEN)    
    lcd.write_text("0.85inch",30,85,1,GREEN)
    lcd.write_text("LCD Module",25,95,1,GREEN)
   
    lcd.hline(7,20,110,BLUE)
    lcd.hline(7,110,110,BLUE)
    lcd.vline(7,20,90,BLUE)
    lcd.vline(117,20,90,BLUE)
    
    lcd.hline(2,10,120,BLUE)
    lcd.hline(2,119,120,BLUE)
    lcd.vline(2,10,110,BLUE)
    lcd.vline(122,10,110,BLUE) 
    lcd.display()
    time.sleep(3)
    
    lcd.fill_rect(0,0,128,14,RED)
    lcd.rect(0,0,128,14,RED)
    
    lcd.fill_rect(0,14,128,14,BLUE)
    lcd.rect(0,14,128,14,BLUE)
    
    lcd.fill_rect(0,28,128,14,GREEN)
    lcd.rect(0,28,128,14,GREEN)
    
    lcd.fill_rect(0,42,128,14,0X07FF)
    lcd.rect(0,42,128,14,0X07FF)
    lcd.fill_rect(0,56,128,14,0xF81F)
    lcd.rect(0,56,128,14,0xF81F)
    lcd.fill_rect(0,70,128,14,0x7FFF)
    lcd.rect(0,70,128,14,0x7FFF)
    lcd.fill_rect(0,84,128,14,0xFFE0)
    lcd.rect(0,84,128,14,0xFFE0)
    lcd.fill_rect(0,98,128,14,0XF0F0)
    lcd.rect(0,98,128,14,0XF0F0)
    lcd.fill_rect(0,112,128,16,0XF0EF)
    lcd.rect(0,112,128,16,0XF0EF)

    lcd.display()

    

   


