/*****************************************************************************
* | File      	:   LCD_0IN85.c
* | Author      :   Waveshare team
* | Function    :   Hardware underlying interface
* | Info        :
*                Used to shield the underlying layers of each master 
*                and enhance portability
*----------------
* |	This version:   V1.0
* | Date        :   2018-01-11
* | Info        :   Basic version
*
******************************************************************************/
#ifndef __LCD_0IN85_H
#define __LCD_0IN85_H	
	
#include "DEV_Config.h"
#include <stdint.h>

#include <stdlib.h>		//itoa()
#include <stdio.h>


#define LCD_0IN85_HEIGHT 128
#define LCD_0IN85_WIDTH 128


#define HORIZONTAL 0
#define VERTICAL   1

#define LCD_0IN85_SetBacklight(Value) DEV_SetBacklight(Value) 

#define LCD_0IN85_CS_0	    DEV_Digital_Write(DEV_CS_PIN, 0) 
#define LCD_0IN85_CS_1	    DEV_Digital_Write(DEV_CS_PIN, 1)
	                        
#define LCD_0IN85_RST_0	  DEV_Digital_Write(DEV_RST_PIN,0)
#define LCD_0IN85_RST_1	  DEV_Digital_Write(DEV_RST_PIN,1)
	                        
#define LCD_0IN85_DC_0	    DEV_Digital_Write(DEV_DC_PIN, 0)
#define LCD_0IN85_DC_1	    DEV_Digital_Write(DEV_DC_PIN, 1)  

typedef struct{
	UWORD WIDTH;
	UWORD HEIGHT;
	UBYTE SCAN_DIR;
}LCD_0IN85_ATTRIBUTES;
extern LCD_0IN85_ATTRIBUTES LCD;

/********************************************************************************
function:	
			Macro definition variable name
********************************************************************************/
void LCD_0IN85_Init(UBYTE Scan_dir);
void LCD_0IN85_Clear(UWORD Color);
void LCD_0IN85_Display(UWORD *Image);
void LCD_0IN85_DisplayWindows(UWORD Xstart, UWORD Ystart, UWORD Xend, UWORD Yend, UWORD *Image);
void LCD_0IN85_DisplayPoint(UWORD X, UWORD Y, UWORD Color);
void LCD_0IN85_DrawPaint(UWORD x, UWORD y, UWORD Color);
void LCD_0IN85_SetBackLight(UWORD Value);
#endif
